# $Revision: 1.35 $, $Date: 2011/09/23 07:00:54 $
#
# TODO:
# - CUDA support (on bcond)
# - OpenNI (http://openni.org/) + PrimeSensor module
# - XIMEA? cmake file seems to be Win32-specific, but ximea.com has some Linux package
#
# Conditional build:
%bcond_without	gstreamer	# GStreamer support
%bcond_with	pvapi		# PvAPI (AVT GigE cameras) support
%bcond_with	qt		# Qt backend instead of GTK+
%bcond_with	tbb		# Threading Building Blocks support
%bcond_with	unicap		# Unicap support (GPL)
%bcond_with	v4l		# Video4Linux (even V4L2 support currently relies on V4L1 API)
%bcond_with	xine		# XINE support (GPL)
#
Summary:	A library of programming functions mainly aimed at real time computer vision
Summary(pl.UTF-8):	Biblioteka funkcji do grafiki komputerowej w czasie rzeczywistym
Name:		opencv
Version:	2.3.1
Release:	2
Epoch:		1
%if %{with unicap} || %{with xine}
License:	GPL (enforced by used libraries), BSD (opencv itself)
%else
License:	BSD
%endif
Group:		Libraries
Source0:	http://downloads.sourceforge.net/opencvlibrary/OpenCV-%{version}a.tar.bz2
# Source0-md5:	82e4b6bfa349777233eea09b075e931e
Patch0:		%{name}-cflags.patch
Patch1:		%{name}-link.patch
Patch2:		%{name}-unicap-c++.patch
Patch3:		%{name}-c.patch
Patch4:		%{name}-gcc.patch
Patch5:		%{name}-multilib.patch
URL:		http://opencv.willowgarage.com/
%{?with_pvapi:BuildRequires:	AVT_GigE_SDK-devel}
BuildRequires:	OpenEXR-devel
BuildRequires:	cmake >= 2.4
BuildRequires:	doxygen
BuildRequires:	eigen >= 2
BuildRequires:	ffmpeg-devel >= 0.7
%if %{with gstreamer}
BuildRequires:	gstreamer-devel >= 0.10
BuildRequires:	gstreamer-plugins-base-devel >= 0.10
%endif
BuildRequires:	jasper-devel
BuildRequires:	libdc1394-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libraw1394-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtiff-devel
BuildRequires:	libtool
%if %{with unicap}
BuildRequires:	libucil-devel
BuildRequires:	libunicap-devel
%endif
BuildRequires:	libv4l-devel
BuildRequires:	pkgconfig
BuildRequires:	python-devel
BuildRequires:	python-numpy-devel
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.606
BuildRequires:	sed >= 4.0
BuildRequires:	swig-python
%{?with_tbb:BuildRequires:	tbb-devel}
%{?with_xine:BuildRequires:	xine-lib-devel}
BuildRequires:	zlib-devel
%if %{with qt}
BuildRequires:	OpenGL-devel
BuildRequires:	QtCore-devel >= 4
BuildRequires:	QtGui-devel >= 4
BuildRequires:	QtOpenGL-devel >= 4
BuildRequires:	qt4-qmake >= 4
%else
BuildRequires:	gtk+2-devel >= 2.0
%endif
# ipp (libippi): http://software.intel.com/en-us/articles/intel-ipp/ (proprietary)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
OpenCV (Open Source Computer Vision) is a library of programming
functions mainly aimed at real time computer vision.

Example applications of the OpenCV library are:
- Human-Computer Interaction (HCI)
- Object Identification, Segmentation and Recognition
- Face Recognition
- Gesture Recognition
- Motion Tracking
- Ego Motion, Motion Understanding
- Structure From Motion (SFM)
- Stereo and Multi-Camera Calibration and Depth Computation
- Mobile Robotics.

%description -l pl.UTF-8
OpenCV (Open Source Computer Vision) to biblioteka funkcji
przeznaczonych głównie do grafiki komputerowej w czasie rzeczywistym.

Przykładowe zastosowania biblioteki OpenCV to
- interakcje człowiek-komputer (HCI)
- identyfikacja, segmentacja i rozpoznawanie obiektów
- rozpoznawanie twarzy
- rozpoznawanie gestów
- śledzenie ruchu
- rozumienie ruchu
- SFM (Structure From Motion)
- kalibracja dwu- i wielokamerowa, obliczanie głębi
- robotyka ruchu.

%package devel
Summary:	Header files for OpenCV library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki OpenCV
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Obsoletes:	opencv-static

%description devel
Header files for OpenCV library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki OpenCV.

%package -n python-opencv
Summary:	OpenCV Python bindings
Summary(pl.UTF-8):	Wiązania Pythona do OpenCV
Group:		Libraries/Python
Requires:	%{name} = %{epoch}:%{version}-%{release}
%pyrequires_eq  python-libs

%description -n python-opencv
OpenCV Python bindings.

%description -n python-opencv -l pl.UTF-8
Wiązania Pythona do OpenCV.

%prep
%setup -q -n OpenCV-%{version}

%undos CMakeLists.txt
%undos modules/gpu/CMakeLists.txt

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
install -d build
cd build
%cmake .. \
%ifarch pentium4 %{x8664}
	-DENABLE_SSE=ON \
	-DENABLE_SSE2=ON \
%else
	-DENABLE_SSE=OFF \
	-DENABLE_SSE2=OFF \
%endif
	-DBUILD_NEW_PYTHON_SUPPORT=ON \
	-DUSE_O3=OFF \
	%{!?with_gstreamer:-DWITH_GSTREAMER=OFF} \
	%{!?with_pvapi:-DWITH_PVAPI=OFF} \
	%{?with_qt:-DWITH_QT=ON -DWITH_QT_OPENGL=ON -DQT_QMAKE_EXECUTABLE=/usr/bin/qmake-qt4} \
	%{?with_tbb:-DWITH_TBB=ON} \
	%{?with_unicap:-DWITH_UNICAP=ON} \
	%{!?with_v4l:-DWITH_V4L=OFF} \
	%{?with_xine:-DWITH_XINE=ON}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_pkgconfigdir}
install build/unix-install/opencv.pc $RPM_BUILD_ROOT%{_pkgconfigdir}

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/opencv_*
%attr(755,root,root) %{_libdir}/libopencv_*.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libopencv_*.so.2.3
%dir %{_datadir}/OpenCV
%doc %{_datadir}/OpenCV/doc
%{_datadir}/OpenCV/haarcascades
%{_datadir}/OpenCV/lbpcascades

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libopencv_*.so
%{_includedir}/opencv
%{_includedir}/opencv2
%{_datadir}/OpenCV/OpenCVConfig*.cmake
%{_pkgconfigdir}/opencv.pc

%files -n python-opencv
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/cv2.so
%{py_sitedir}/cv.py[co]

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: opencv.spec,v $
Revision 1.35  2011/09/23 07:00:54  lisu
- rel 2

Revision 1.34  2011/09/22 16:05:01  qboosh
- use more recent cmake macro features (macros >= 1.606)
- fixed python module packaging
- updated TODO; I'd suggest not to rename package each time upstream decides to change case of letters and back, it's too messy

Revision 1.33  2011/09/21 07:37:42  lisu
- lib64 not yet supported for python by upstream
- multilib.patch restored

Revision 1.32  2011/09/21 07:21:58  lisu
- upstream support lib64 now

Revision 1.31  2011/09/21 07:05:09  lisu
- updated to 2.3.1a
- multilib.patch and ffmpeg-0.8.patch are obsoleted
- cmake macro was fixed in rpmbuild(macros) 1.600
- sorted BRs
- changes in %%files

Revision 1.30  2011/07/24 15:54:23  arekm
- release 10

Revision 1.29  2011/07/03 09:06:57  qboosh
- updated ffmpeg-0.8 patch to be compatible with ffmpeg 0.7
- release 9

Revision 1.28  2011/06/29 16:59:52  qboosh
- added gcc patch (fixes build with gcc 4.6)
- added ffmpeg-0.8 patch (ffmpeg API updates)
- disable all v4l support by default for now (V4L2 code heavily depends on V4L1 being enabled)

Revision 1.27  2011/06/27 19:22:16  arekm
- release 8

Revision 1.26  2011/03/10 17:05:07  qboosh
- added c patch (C compatibility for legacy headers)
- release 7

Revision 1.25  2011/01/29 09:05:14  qboosh
- qt bcond (GTK+ is the default)

Revision 1.24  2011/01/24 16:08:29  qboosh
- added unicap-c++ patch (workaround for "private" field name being a keyword in C++)
- added tbb support (on bcond)
- BR: eigen 2

Revision 1.23  2011/01/23 18:06:59  qboosh
- gstreamer enabled by default
- added options/bconds/BRs for unicap and pvapi

Revision 1.22  2011/01/23 06:42:37  qboosh
- updated cflags patch to remove -march=i686 from CFLAGS
- pass cmake options to disable -O3 overrides and -msse/-msse2 on CPUs which possibly don't support SSE

Revision 1.21  2011/01/22 20:46:56  qboosh
- pl
- more BRs
- static gone due to cmake

Revision 1.20  2010/12/12 00:37:42  arekm
- rel 6

Revision 1.19  2010/12/12 00:30:40  arekm
- rel 5; try to fix lib64

Revision 1.18  2010/12/12 00:13:44  arekm
- release 4

Revision 1.17  2010/12/11 23:55:26  arekm
- release 3

Revision 1.16  2010/12/07 15:45:01  lisu
- package opencv2 header files
- rel 2

Revision 1.15  2010/12/07 12:52:09  lisu
- more undos

Revision 1.14  2010/12/07 12:31:58  lisu
- update to 2.2.0
- libpng14.patch and mmap.patch are obsoleted
- update multilib.patch to fit new source structure
- add link.patch which force linking with -lv4l2
- drop cmake options provided by cmake macro
- BRs: rpmbuild(macros) >= 1.577 (for cmake macro), sed >= 4.0 (for undos macro)
- no ghost soname symlink this time

Revision 1.13  2010/11/25 11:00:05  hawk
- added skip_post_check_so to allow build

Revision 1.12  2010/08/13 13:05:24  lisu
- TODO

Revision 1.11  2010/08/13 11:59:47  arekm
- files updated

Revision 1.10  2010/08/13 11:07:23  lisu
- build with -D__STDC_CONSTANT_MACROS flag to avoid errors (-cflags.patch)

Revision 1.9  2010/08/13 10:27:58  arekm
- start updating to 2.1.0

Revision 1.8  2010/01/30 15:50:09  sparky
- BR: pkgconfig

Revision 1.7  2010/01/29 19:52:45  arekm
- rel .6

Revision 1.6  2009/07/14 11:33:50  arekm
- rel 5; build fixed

Revision 1.5  2009/07/03 20:55:05  hawk
- strict internal dep for python-opencv, release 4

Revision 1.4  2009/07/02 14:34:11  hawk
- killed duplicate install

Revision 1.3  2009/03/18 22:25:14  arekm
- ffmpeg fixes, xine fixes, python fixes

Revision 1.2  2009/03/18 21:47:11  arekm
- add BR: swig-python

Revision 1.1  2009/03/18 21:26:16  arekm
- initial
